var shoppingCart = new Vue({
    el: "#shoppingCart",
    data: {
        userId: 0,
        userIdentity: '',
        userToken: '',
        listLoading: true,
        listData: [],
        invalidData: [],
        kindCount: 0,
        totalCount: 0,
        totalPrice: 0,
        allChecked: true,
        submitIds: [],//去结算商品Ids

    },
    computed: {

    },
    methods: {
        getCartLists: function () {
            var _self = this;
            if(this.userId ===0){return;}
            tokenAjax("get", "/shoppingCart/list", {userId: this.userId},function (r) {
                if (r.code === 0 && r.data) {
                    _self.listData = r.data.list;
                    _self.invalidData = r.data.invalid;
                    _self.kindCount = r.data.kindCount;
                    _self.totalCount = r.data.totalCount;
                    _self.totalPrice = r.data.totalPrice;
                    // 默认全选
                    _self.listData.forEach(function(supplier){
                        supplier.checked = true;
                        if(supplier.cartList.length>0){
                            supplier.cartList.forEach(function(cartItem){
                                _self.submitIds.push(cartItem.productId);
                            })
                        }
                    });
                    _self.allChecked = true;
                }
                _self.listLoading = false;
            });
        },
        toggleThisLadder: function(event){
            var el = event.currentTarget;
            if($(el).hasClass("on")){
                $(el).removeClass("on").siblings('.ladder').hide();
                if(!isPC){looseBody();}
            }else{
                $(el).addClass("on").siblings('.ladder').show();
                if(!isPC){fixedBody();}
            }
        },
        hideThisLadder: function(event){
            var el = event.currentTarget;
            $(el).parents('.priceTag').find('.tag').removeClass("on").siblings('.ladder').hide();
            if(!isPC){looseBody();}
        },
        ckeckSupplier: function(event, supplierChecked){
            var el = event.currentTarget;
            var _self = this;
            var cartList = $(el).parents('.supplierItem').find('input[name=cartList]');
            this.$nextTick(function(){
                if (supplierChecked) {
                    $.each(cartList, function (index, item) {
                        if (!_self.submitIds.includes(item.value*1)){
                            _self.submitIds.push(item.value*1);
                        }
                    });
                }else{
                    $.each(cartList, function (index, item) {
                        var loc = _self.submitIds.indexOf(item.value*1);
                        if(loc >=0 ){
                            _self.submitIds.splice(loc, 1);
                            _self.allChecked = false;
                        }
                    });
                }
                _self.computedPrice();
            });
        },
        ckeckAll: function(){
            var _self = this;
            this.$nextTick(function(){
                if (_self.allChecked) {
                    _self.submitIds = [];
                    _self.listData.forEach(function(supplier){
                        supplier.checked = true;
                        if(supplier.cartList.length>0){
                            supplier.cartList.forEach(function(cartItem){
                                _self.submitIds.push(cartItem.productId);
                            })
                        }
                    });
                }else{
                    _self.submitIds = [];
                    _self.listData.forEach(function(supplier){
                        supplier.checked = false;
                    });
                }
                _self.computedPrice();
            });
        },
        computedPrice: function(){
            var _self = this;
            this.$nextTick(function(){
                var totalPrice = 0;
                var kindCount = 0;
                var totalCount = 0;
                _self.listData.forEach(function(supplier){
                    var supplierPrice = 0;
                    if(supplier.cartList.length>0){
                        supplier.cartList.forEach(function(cart){
                            if (_self.submitIds.includes(cart.productId*1)){
                                supplierPrice += cart.price*cart.number;
                                kindCount += 1;
                                totalCount += cart.number;
                            }
                        })
                    }
                    supplier.totalPrice = supplierPrice;
                    totalPrice += supplier.totalPrice;
                });
                _self.totalPrice = totalPrice;
                _self.kindCount = kindCount;
                _self.totalCount = totalCount;
            });
        },
        cartNumberSub: function(cart){
            cart.number -= cart.step;
            if (cart.number<cart.min){
                cart.number = cart.min;
            }
            this.numberChange(cart);
        },
        cartNumberAdd: function(cart){
            cart.number += cart.step;
            this.numberChange(cart);
        },
        cartNumberChange: function(cart){
            cart.number = Math.ceil(cart.number/cart.step)*cart.step;
            this.numberChange(cart);
        },
        numberChange: function(cart){
            if(cart.ladderFlag){
                cart.ladderPrices.forEach(function(ladder){
                    if(cart.number>=ladder.buyNum){
                        cart.price = ladder.buyPrice;
                    }
                });
            }
            // 计算价格
            this.computedPrice();
            // 更新购物车
            var _self = this;
            this.$nextTick(function(){
                tokenAjax("post", "/shoppingCart/update", {
                    userID: this.userId,
                    productID: cart.productId,
                    productCount: cart.number
                },function (res) {
                    console.log(res);
                });
            });
        },
        deleteCart: function(cartId){
            alertInfo("确定要删除该商品？",function(){
                // 删除逻辑
                alert("test")
            })
        },

    },
    created: function () {
        if(globalUserData){
            this.userId = globalUserData.userId;
            this.userIdentity = globalUserData.identity;
            this.userToken = globalUserData.token;
        }
        // 获取列表数据
        this.getCartLists();
    },
    mounted: function () {
        var _self = this;
        var minAwayBtm = $("footer").height();
        //处理滚动条控制底部提交fixed
        $(window).scroll(function() {
            var awayBtm = $(document).height() - $(window).scrollTop() - $(window).height();
            if(minAwayBtm <= awayBtm){
                $(".summaryWrap").addClass('fixed');
            }else{
                $(".summaryWrap").removeClass("fixed");
            }
        });
    }
});
